﻿using System;
using System.Diagnostics;
using System.Threading;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace TestProject
{
    /// <summary>
    /// 메인 폼
    /// </summary>
    public partial class MainForm : Form
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Constructor
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 생성자 - MainForm()

        /// <summary>
        /// 생성자
        /// </summary>
        public MainForm()
        {
            InitializeComponent();

            this.executeButton.Click += executeButton_Click;
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Private
        //////////////////////////////////////////////////////////////////////////////// Event

        #region 실행 버튼 클릭시 처리하기 - executeButton_Click(sender, e)

        /// <summary>
        /// 실행 버튼 클릭시 처리하기
        /// </summary>
        /// <param name="sender">이벤트 발생자</param>
        /// <param name="e">이벤트 인자</param>
        private async void executeButton_Click(object sender, EventArgs e)
        {
            Trace.WriteLine("BEGIN EXECUTE BUTTON CLICK");

            Trace.WriteLine($"현재 스레드 : {Thread.CurrentThread.ManagedThreadId}");

            Task task = ExecuteAsync();

            Trace.WriteLine($"현재 스레드 : {Thread.CurrentThread.ManagedThreadId}");

            task.Wait(); // 교착 상태가 된다.

            Trace.WriteLine("END EXECUTE BUTTON CLICK");
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////// Function

        #region 실행하기 (비동기) - ExecuteAsync()

        /// <summary>
        /// 실행하기 (비동기)
        /// </summary>
        /// <returns>태스크</returns>
        private async Task ExecuteAsync()
        {
            Trace.WriteLine("BEGIN EXECUTE ASYNC FUNCTION");

            Trace.WriteLine($"ExecuteAsync 현재 스레드 : {Thread.CurrentThread.ManagedThreadId}");

            await Task.Delay(TimeSpan.FromSeconds(1));
          //await Task.Delay(TimeSpan.FromSeconds(1)).ConfigureAwait(false); // 교착 상태를 회피한다.

            Trace.WriteLine($"ExecuteAsync 현재 스레드 : {Thread.CurrentThread.ManagedThreadId}");

            Trace.WriteLine("END EXECUTE ASYNC FUNCTION");
        }

        #endregion
    }
}